/*
    version:2
    update time:07/13/2018
*/
(function() {
    function hideSibling(currentNode) {
        var preSibling = currentNode.previousElementSibling;
        while (preSibling) {
            preSibling.style.display = "none";
            preSibling = preSibling.previousElementSibling;
        }

        var nextSibling = currentNode.nextElementSibling;
        while (nextSibling) {
            nextSibling.style.display = "none";
            nextSibling = nextSibling.nextElementSibling;
        }
    }

    var bingResult = document.getElementById("b_results");
    if (!bingResult) {
        window.FILTER.error();
        return;
    }

    var parentNode = bingResult.parentElement;
    do {
        hideSibling(parentNode);
        parentNode = parentNode.parentElement;
    } while (parentNode.nodeName.toLowerCase() !== "body");

    hideSibling(bingResult);

    /*  exclude the pager and the result which under pager */
    var isHidden = false;
    for (var resultIndex = 0; resultIndex < bingResult.childNodes.length; resultIndex++) {
        var resultNode = bingResult.childNodes[resultIndex];
        if (resultNode &&
            resultNode.className.toLowerCase() === "b_pag") {
            isHidden = true;
        }

        if (isHidden === true) {
            resultNode.style.display = "none";
            continue;
        }

        /* hide related search answer*/
        if (resultNode.querySelector(".b_rs")) {
            resultNode.style.display = "none";
        }
    }

    var actionMenu = document.getElementsByClassName("topactions");
    for (var menuIndex = 0; menuIndex < actionMenu.length; menuIndex++) {
        actionMenu[menuIndex].style.display = "none";
    }

    var menuBar = document.getElementById("b_header");
    var style = window.getComputedStyle(menuBar, null).getPropertyValue("display");
    if ("none" === style.toLowerCase()) {
        window.FILTER.processedHTML();
    } else {
        var duration = 500;
        var timeout = 100 * 10;
        var totalTime = 0;
        var interval = setInterval(function() {
            style = window.getComputedStyle(menuBar, null).getPropertyValue("display");
            if ("none" === style.toLowerCase()) {
                clearInterval(interval);
                window.FILTER.processedHTML();
            } else {
                totalTime += duration;
                if (totalTime > timeout) {
                    clearInterval(interval);
                    totalTime = 0;
                    window.FILTER.error();
                }
            }
        }, duration);
    }
})();
