((needCallBridge) => {
    // Don't forget to update descriptor version in SearchDataManager-isOpalWebDescriptorScriptUpdated

    var response = {};
    var entityClass = "b_ans";
    var entityTypeMap = {
        "Alt": "#sp_requery",
        "IsAmbHeader": "#wpdisamb",
        "UnitConvert": "#rich_uc",
        "Stock": "#financeAnswer",
        "TopNews": ".mncap",
        "Dictionary": ".dcont", // Dictionary on top?
        "QnAwithImage": "#qna_imgtt_img",
        "TextQnA": ".df_c  .rwrl",
        "RelatedQnA": ".rqnaContainer",
        "SearchRefiner": "#cvnMt", // e.g. Query: Lace dress. -> What length are you looking for? short, long
        "SingleVideo": "#singleVideoHero",
        "Grid": "#b_gridCarousel",
        "WaterFall": "#b_wfCarousel",
        "VerticalCarousel": "#b_vCarousel",
        "DirectionMobile": "#dr_mobile",
        "ImagesContainer": "[data-partnertag=\"Multimedia.ImagesContainer\"]",
        "Calculator": "#rcCalB",
        "Map":"[data-tag=\"common.MapControl\"]",
        "News": "#mnwsc",
        "NewsContainer": "[data-tag=\"NewsAnswer.Container\"]",
        "Twitter": "#twcrsl",
        "Weather": ".wtr_core",
        "List": "#b_listContainer",
        "Tab": "[role=tab]",
        "Info": "#wpc_tp", // Information Panel
        "Lrc": ".musicAnswerHeroLyrics", // Lyrics
        "RelVideos": "#rvsc", // Related Videos
        "Images": ".b_img_header",
        "Videos": ".b_video_header",
        "Disamb": ".disamb",
        "FakeBlue": ".wpcbc", // Fake blue link
        "AppDownload": ".asc_container"
    };
    var ignoredTypes = ["DirectionMobile", "Info", "Disamb", "FakeBlue"];

    var tabListSelector = "[role=tab]";
    var tabNameAttrName = "data-tabkey";
    var adItemClass = "ad_sc";
    var blueLinkClass = "b_algo";

    var isListEmpty = list => {
        if (list && typeof list == "object") {
            return list.length == 0;
        }

        return true;
    };

    var getInfoPanelType = InfoPanel => {
        // todo: finish this method
    };

    var getTabTypes = dom => {
        // todo: use this method
        if (!dom) {
            return null;
        }

        var tabList = dom.querySelectorAll(tabListSelector);
        var tabTypes = [];
        if (!isListEmpty(tabList)) {
            for (var t = 0; t < tabList.length; t++) {
                var tabName = tabList[t].getAttribute(tabNameAttrName); // This already starts with 'Tab_
                if (!tabName) {
                    tabName = "Tab_" + (tabList[t].textContent ? tabList[t].textContent.trim() : "Unknown");
                }

                tabTypes.push(tabName);
            }
        }

        return tabTypes;
    };

    var identifyEntities = doms => {
        var types = [];
        var unknownTypeName = "X";
        for (var i = 0; i < doms.length; i++) {
            var dom = doms[i];
            var isClassified = false;

            for (var type in entityTypeMap) {
                if (dom.querySelector(entityTypeMap[type])) {
                    isClassified = true;
                    if (!ignoredTypes.includes(type)) {
                        types.push(type);
                    }

                    break;
                }
            }

            if (!isClassified) {
                types.push(unknownTypeName);
                console.log("Uncatogorized Block: \n\t" + dom.innerHTML);
            }
        }

        return types;
    };

    try {
        // region Entities Supportability
        if (!/["']opalwebsupported["'][,=]\s*["']true["']/.test(document.getElementsByTagName('html')[0].innerHTML.toLowerCase())) {
            response.HasEntity = "Unsupported";
            return response;
        }
        // end region

        // region Entity
        var doms = document.getElementsByClassName(entityClass);
        response.HasEntity = "No";
        if (doms && doms.length > 0) {
            response.HasEntity = "Yes";
            response.EntityTypes = identifyEntities(doms).join(">");
            response.TriggeringQuery = document.getElementsByTagName("title")[0].innerText;
        }
        // end region

        // region Ads
        doms = document.getElementsByClassName(adItemClass);
        response.HasAd = (doms && doms.length > 0) ? "Yes" : "No";
        // end region

        // region BlueLinks
        doms = document.getElementsByClassName(blueLinkClass);
        response.HasBlueLinks = (doms && doms.length > 0) ? "Yes" : "No";
        // end region

        return response;
    } catch (err) {
        return {};
    } finally {
        if (needCallBridge) {
            OpalWebViewBridgeInterface.sendDescription(response);
        }
    }
})(false);