var VideoType = {
    YouTube: "youtube", Facebook: "facebook", Instagram: "instagram", Twitter: "twitter"
}

var config = { childList: true, subtree: true };
var videoType = undefined;
var hostname = document.location.hostname;
var video = isVideoExisted();
var muted = undefined;

function isVideoExisted() {
    let videos = document.getElementsByTagName("video");
    return videos && videos.length > 0 && videos[0];
}

function postMessage(data) {
    parent.postMessage(data, "http://sabingdevhyp509");
    parent.postMessage(data, "http://stcvm-456");
    parent.postMessage(data, "http://stcvm-ls197");
    parent.postMessage(data, "http://stcac-138");
    parent.postMessage(data, "http://stcac-170");
    // TODO: post message to bing.com
}

function onVolumeChange(event) {
    console.log("Android onVolumeChange in muted:" + muted + ", event muted:" + event.target.muted);
    if (muted !== undefined && event.target.muted !== muted) {
        console.log("Android onVolumeChange:" + event.target.muted);
        muted = event.target.muted;
        console.log("Android onVolumeChange after muted:" + muted + ", event muted:" + event.target.muted);
        postMessage({ muted: muted });
    }
}

function handleMessage(event) {
    //console.log("Android handleMessage in");
    if (videoType) {
        var origin = event.origin;
        var srcElement = event.srcElement;

        if (origin === "http://sabingdevhyp509" || origin === "http://stcvm-456" || origin === "http://stcvm-ls197"
            || origin === "http://stcac-170" || origin === "http://stcac-138") {
            // TODO: add bing.com
            var data = event.data;
            //console.log(data);
            switch (videoType) {
                case VideoType.Facebook:
                case VideoType.YouTube:
                    //console.log("Android handle message facebook or youtube");
                    if (srcElement.location.host.indexOf("facebook.com") > -1 || srcElement.location.host === "www.youtube.com") {
                        if (data.muted !== undefined) {
                            // Muted
                            muted = data.muted;
                            console.log("Android muted:" + muted);
                        }
                    }

                    break;
                case VideoType.Instagram:
                    //console.log("Android handle message instagram");
                    if (video && srcElement.location.host === "www.instagram.com") {
                        if (data.muted !== undefined) {
                            // Muted
                            muted = data.muted;
                            video.muted = data.muted;
                            console.log("Android instagram muted:" + muted);
                        }

                        if (data.play) {
                            // Play
                            var parent = video.parentElement;
                            if (parent && parent.childNodes) {
                                var images = parent.getElementsByTagName("img");
                                if (images && images.length > 0 && images[0]) {
                                    images[0].style.visibility = "hidden"
                                }
                            }

                            var playButtons = document.getElementsByClassName("videoSpritePlayButton");
                            if (playButtons && playButtons.length > 0 && playButtons[0]) {
                                playButtons[0].setAttribute("class", playButtons[0].getAttribute("class").replace("PTIMp", ""));
                            }

                            video.play();
                        } else if (data.pause) {
                            // Pause
                            video.pause();
                        }
                    }

                    break;
                case VideoType.Twitter:
                    console.log("Android handle message twitter:" + srcElement.location.host + ", video:" + video);
                    console.log(data);
                    if (video && srcElement.location.host === "twitter.com") {
                        console.log("Android twitter in");
                        if (data.muted !== undefined) {
                            // Muted
                            muted = data.muted;
                            video.muted = data.muted;
                            console.log("Android twitter muted:" + muted);
                        }

                        if (data.play) {
                            // Play
                            if (document) {
                                if (video.currentTime === video.duration) {
                                    video.play();
                                }

                                video.play();
                                console.log("Android twitter play");
                            } else {
                                parent.postMessage({ /* id: id,  */video: false }, "http://sabingdevhyp509");
                                parent.postMessage({ /* id: id,  */video: false }, "http://stcvm-456");
                                // TODO: post message to bing.com
                            }
                        } else if (data.pause) {
                            // Pause
                            video.pause();
                        }
                    }

                    break;
            }
        }
    }
}

function modifyVideo() {
    if (videoType && video) {
        console.log("Android bind message");
        window.addEventListener('message', handleMessage, false);
        switch (videoType) {
            case VideoType.Facebook:
                // Modify for IOS
                if (!video.hasAttribute("playsinline")) {
                    video.setAttribute("playsinline", true);
                }

                // Modify for Android
                if (video.hasAttribute("controlslist")) {
                    video.setAttribute("controlslist", video.getAttribute("controlslist") + " nofullscreen");
                } else {
                    video.setAttribute("controlslist", "nofullscreen");
                }

                break;
            case VideoType.Twitter:
                postMessage({ loaded: true });
                break;
        }

        // Mute globally
        video.muted = true;
        if (videoType !== VideoType.Instagram) {
            video.onvolumechange = function (event) { onVolumeChange(event); }
        }
    }
}

function observeElement() {
    //console.log("Android modify video:" + videoType);
    if (videoType) {
        var targetNode = document.body;
        switch (videoType) {
            case VideoType.Facebook:
                targetNode = document.getElementById('u_0_1');
                break;
        }

        //console.log(targetNode);
        var callback = function (mutationList, observer) {
            video = isVideoExisted();
            //console.log(video);
            if (video) {
                console.log("Android modify video2");
                //console.log(video);
                modifyVideo();
                observer.disconnect();
            }
        }

        var observer = new MutationObserver(callback);
        observer.observe(targetNode, config);
    }
}

console.log("Android hostname:" + hostname);
if (hostname.indexOf("facebook.com") > -1) {
    videoType = VideoType.Facebook;
} else if (hostname.indexOf("youtube.com") > -1) {
    videoType = VideoType.YouTube;
    console.log("Android youtube video");
} else if (hostname.indexOf("instagram.com") > -1) {
    videoType = VideoType.Instagram;
} else if (hostname.indexOf("twitter.com") > -1) {
    videoType = VideoType.Twitter;
}

if (video) {
    console.log("Android modify video");
    modifyVideo();
} else {
    console.log("Android observe");
    observeElement();
}